import javax.servlet.*;
import javax.servlet.http.*;
//#import javax.servlet.*;
//#import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.net.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;

/**
 * Simple mail servlet
 * Michael servlets@xoommail.com)
 * 6/3/98 rev 1.0
 */

public
class MailServlet extends HttpServlet { 
  String to;
  String from;
  String subject;
  String text;
  String host = "localhost";
  Session session;

    public void init(ServletConfig conf) throws ServletException {
      super.init(conf);
    
      // create some properties and get the default Session
      Properties props = new Properties();
      props.put("mail.smtp.host", host);

      session = Session.getDefaultInstance(props, null);
      session.setDebug(false);
    }

    public void doGet (HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
        res.setContentType("text/html");
        ServletOutputStream out = res.getOutputStream();

        to = req.getParameter("to");
        from  = req.getParameter("from");
        subject = req.getParameter("subject");
        text = req.getParameter("text");

        out.println
            ("<HEAD><TITLE> Mail Servlet Output </TITLE></HEAD><BODY>");

        out.println("<h1> MailServlet output </h1>");
        out.println("<p>");
   
        if (to == null) {
            out.println("Error: No to");
        } else if (from == null) {
            out.println("Error: No from");
        } else {
          try {
          // create a message
          Message msg = new MimeMessage(session);
          msg.setFrom(new InternetAddress(from));
          InternetAddress[] address = {new InternetAddress(to)};
          msg.setRecipients(Message.RecipientType.TO, address);
          msg.setSubject(subject);
          msg.setText(text);

          Transport.send(msg);

          out.println("<HR>");
          out.println("<PRE>");
          out.print("     To: " + to + "<BR>");
          out.print("   From: " + from + "<BR>");
          out.print("Subject: " + 
                     ((subject != null) ? subject : "None") + "<BR>");
          out.print("   Body:<BR>");
          out.println("</PRE><HR>");
          out.println((text != null) ? text : "None");
          out.println("<p><BR><BR><HR>\nMail Delivered");

        } catch(MessagingException mex) {
            out.println("Error:");
            out.println(mex.getMessage());
             mex.printStackTrace ();
        }
      } //else

        out.println("</BODY>");

    }

    public String getServletInfo() {
        return "Simple Mail Servlet using JavaMail API";
    }
}
