import java.io.*;
import java.net.*;
import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;

/**
 * @author  Michael (servlets@xoommail.com)
 */
public
class MakeTable extends HttpServlet { 
    private Vector table;
	private Properties MakeTableProps = new Properties();
	private String fileName = "";
	
    public void init(ServletConfig conf) throws ServletException {
		
        super.init(conf);
        log("initialize: enter");
		
    }

    public void doGet (HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
		String delim = ",";
		
		res.setContentType("text/html");
		ServletOutputStream out = res.getOutputStream();
		
		out.println("<HEAD><TITLE> MakeTable Servlet Output </TITLE></HEAD><BODY>");
		
		if ( (fileName = req.getParameter("fileName")) == null) {
			out.println("Missing parameter: fileName");
			out.println("</body>");
			out.flush();
			out.close();
			return;
		}
		
		if (req.getParameter("delim") != null) {
			delim = req.getParameter("delim");
		}
		
        String title = "Table";
       
		log("initialize: filename = " + fileName);
		table = readVector(fileName);
		
        out.println("<h1> MakeTable output </h1>");
        out.println("<p>");
		displayTable(table, delim, out);
        out.println("</BODY>");
		out.flush();
		out.close();
    }

	public void displayTable(Vector v, String delim, ServletOutputStream o) 
						throws ServletException, IOException {
		boolean header = true;
		Enumeration e = v.elements();
		o.println("<table");
		o.println("border=1 width=100% cellspacing=0 cellpadding=5>");
		while (e.hasMoreElements()) {
			o.println("<tr>");
			Enumeration e1 = new StringTokenizer((String)(e.nextElement()), delim);
			while (e1.hasMoreElements()){
				o.println((header ? "<th>" : "<td>"));
				o.println( e1.nextElement().toString());
				o.println((header ? "</th>" : "</td>"));
			}
			o.println("</tr>");
			header = false;
		}
		o.println("</table>");
	}		
	
    public String getServletInfo() {
        return "This servlet converts a csv file to an html table";
    }
	public static Vector readVector (String file)
	{
	Vector v = new Vector();
	try
		{
		FileInputStream f = new FileInputStream ( file );
		DataInputStream in = new DataInputStream ( f );
		String s = "";
		while (true)
			{
			s = in.readLine();
			if ( s == null ) break;
			v.addElement ( s );
			}
		f.close();
		}
	catch (IOException e)
		{
		e.printStackTrace();
		System.out.println("error:-> " + e.getMessage());
		v.addElement ( "file error" ); v.addElement ( "not read" );
		}
	System.out.println ( ": loadVector()");
 	System.out.println ( v.toString() );
	return v;
	}

}
