/* 
 *  Java pizza applet using servlets and GridBagLayout
 */

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.net.*;
import java.io.*;

public class pizza extends Applet implements ActionListener
{
   private Choice yesNo;
   private Choice name;
  
  
   private TextField addressField = new TextField();
   private TextField phoneField = new TextField();
   private TextField pizzaField = new TextField();
   
   private CheckboxGroup topping;
   private CheckboxGroup Ordertopping;
   private String str;
   private TextArea TAspecials;
   private TextArea TAorder;

   // special add method for GridBadLayout
   private void add(Component c, 
      GridBagLayout gbl, GridBagConstraints gbc,
      int x, int y, int w, int h)
	
   {  gbc.gridx = x;
      gbc.gridy = y;
      gbc.gridwidth = w;
      gbc.gridheight = h;
      gbl.setConstraints(c, gbc);
      add(c);
   }


  // sets up form 
  public void init()
   {  
	Component c;
	resize(600,1000);
	GridBagLayout gbl=new GridBagLayout();
	setLayout(gbl);
	GridBagConstraints gbc= new GridBagConstraints();
	gbc.fill=GridBagConstraints.BOTH;
	gbc.weightx=100;
	gbc.weighty=100;
	setFont(new Font("TimesRoman", Font.BOLD, 16));
	int yoff=1;
	

	c=new Label("Fill-Out Form Example");
	c.setFont(new Font("TimesRoman", Font.BOLD, 34));
	add(c,gbl,gbc,0,0,4,2);
	
	c=new Label(" A fill-out form example, with multiple text entry fields and radio buttons..");
	c.setFont(new Font("Curier", Font.BOLD, 13));
 	add(c,gbl,gbc,0,2,4,1);


	c=new Label("Internet Pizza Delivery Service");
	c.setFont(new Font("TimesRoman", Font.BOLD, 24));
	add(c,gbl,gbc,0,3,4,1);

	c=new Label(" ====================================================================================================================");
	c.setFont(new Font("TimesRoman", Font.BOLD, 8));
	add(c,gbl,gbc,0,4,4,1);
	
     	/*_____________________________________________________________*/
	yoff=5;
	add(new Label(" "),gbl,gbc,0,yoff,4,1);
	c=new Label("Would you like to view (today's) specials?");
	c.setFont(new Font("TimesRoman", Font.BOLD, 18));
	c.setForeground(Color.red);
	add(c,gbl,gbc,0,yoff+1,4,1);
	
	
	gbc.fill=GridBagConstraints.NONE;
	yesNo= new Choice();
	yesNo.setFont(new Font("TimesRoman", Font.BOLD, 16)); 
	yesNo.addItem("Yes");
	yesNo.addItem("No");
 	add(yesNo,gbl,gbc,1,yoff+2,1,1);
	
	gbc.fill=GridBagConstraints.VERTICAL;
	Button vs=new Button("View Specials");
	vs.addActionListener(this);
	c=vs;
	c.setBackground(Color.yellow);
	c.setForeground(Color.blue);
	add(vs,gbl,gbc,2,yoff+2,1,1);
	
	gbc.fill=GridBagConstraints.BOTH;
	TAspecials=new TextArea(10,40);
	add(TAspecials,gbl,gbc,0,yoff+3,4,4);
	
      /*______________________________________________________________*/ 	
	yoff=yoff+9;
	
	add(new Label(" "),gbl,gbc,0,yoff-1,4,1);
	c=new Label("Order Form");
	c.setFont(new Font("TimesRoman", Font.BOLD, 18));
	c.setForeground(Color.red);
	add(c,gbl,gbc,0,yoff,4,1);

	
	Panel address =new Panel();
	address.setLayout(new GridLayout(3,2));
	address.setFont(new Font("TimesRoman", Font.BOLD, 14));
	address.add(new Label("Type in your street address:"));
	address.add(addressField=new TextField(20));
	address.add(new Label("Type in your phone number:"));
	address.add(phoneField=new TextField(10));
	address.add(new Label("Choose a special pizza:"));
	address.add(pizzaField=new TextField(20));
	add(address,gbl,gbc,0,yoff+1,4,4);
	c=new Label("Or you may prefer to choose a topping for your pizza: ");
	c.setFont(new Font("TimesRoman", Font.BOLD, 15));
	add(c,gbl,gbc,0,yoff+5,4,1);
	
	Panel pTop2=new Panel();
	pTop2.setLayout(new GridLayout(3,1));	
	Ordertopping = new CheckboxGroup();
	pTop2.add(new Checkbox("Pepperoni",Ordertopping,true));
	pTop2.add(new Checkbox("Sausage",Ordertopping,false));
	pTop2.add(new Checkbox("Anchovy",Ordertopping,false));
	gbc.fill=GridBagConstraints.NONE;
	add(pTop2,gbl,gbc,2,yoff+6,2,2);
	
	
	gbc.fill=GridBagConstraints.HORIZONTAL;
	Button op = new Button("Order Pizza");
	op.addActionListener(this);
	c = op;
	c.setBackground(Color.yellow);
	add(c,gbl,gbc,0,yoff+7,1,1);

	

	gbc.fill=GridBagConstraints.BOTH;
	TAorder=new TextArea(10,40);
	add(TAorder,gbl,gbc,0,yoff+8,4,4);
	
	add(new Label(" "),gbl,gbc,0,yoff+12,4,1);
        c = new Label
         ("class example. Please send comments to njm@npac.syr.edu. 2/28/96.");
	c.setFont(new Font("Courier", Font.BOLD, 12));
	c.setForeground(Color.green);
	add(c,gbl,gbc,0,yoff+13,4,1);
	
  }
 
   public void actionPerformed(ActionEvent evt)
   {
     // call perl script to read specials file and return results
     if (evt.getActionCommand().equals("View Specials"))
      { handleViewSpecials();    }   

     // call perl script to "order pizza"
      else if (evt.getActionCommand().equals("Order Pizza"))
      { handleOrderPizza();      }
   }


    public void handleViewSpecials()
	{
        // sdata is string sent to script, rdata is received from script
	String sdata;
	String rdata;
        // perl script expects one input field (not really used)
	sdata= "todayspecials=" + yesNo.getSelectedItem();
        // location of script on host
       String Script="/PizzaSpecials";
        // Network method handles transaction to web server and returns result
	rdata=Network(sdata,Script);
        // display result string from the file specials.txt
	TAspecials.setText(rdata);
	}

   public void handleOrderPizza()
	{
        // sdata is string sent to script, rdata is received from script
	String sdata;
	String rdata;
	Checkbox c=Ordertopping.getSelectedCheckbox();
    
        /* servlet expects these 4 input fields to be defined in the
         *  input string in the form "field1=value1&field2=value2& . . ."
         *  (we don't encode blanks and special characters)
         */
	sdata = "address=" + addressField.getText()
		+ "&phone=" + phoneField.getText()
		+ "&specialorder="+pizzaField.getText()
		+ "&topping="+c.getLabel();

        // location of script on host
	String Script="/PizzaServlet";

        // Network method handles transaction to web server and returns result
	rdata=Network(sdata,Script);

        // display result (which verifies pizza order)
	TAorder.setText(rdata);
	 
	}
 
    /* This method sets up the socket to the host and creates Stream
     * It formats the input string as an HTTP message by adding the HTTP
     *    header plus one blank line.
     */
   public String Network(String sdata,String script)
   {  // host name
      String home = "class-server.npac.syr.edu";
     
      int port = 61699;
      Socket s = null;
      String rdata = "";

      try
      {  
         s = new Socket(home, port);

         DataOutputStream os
            = new DataOutputStream(s.getOutputStream());
         BufferedReader is
            = new BufferedReader
		(new InputStreamReader(s.getInputStream()));

         // write http header to the output stream followed by sdata string
         os.writeBytes("POST " + script 
            + " HTTP/1.0\r\n" 
	       // several Content-types will work
            + "Content-type: application/octet-stream\r\n"
            + "Content-length: " 
            + sdata.length() + "\r\n\r\n");
         os.writeBytes(sdata);

         /* read lines of result from web server, discard message header
            up to Content-type line */
         String line="";
	   while (((line = is.readLine()) != null)
			&& !(line.startsWith("Content-type:")))
                   { };
         /* append remainging lines, the body of the message, to result.
              This is the output of the perl script.  */
           while ((line = is.readLine()) != null)
         	     { rdata += line + "\n";} 
         showStatus(rdata);
         is.close();
         os.close();
      }
      catch (Exception e)
      {  showStatus("Error " + e);
         if (s != null)
            try
              { s.close(); }
            catch (IOException ex) {}
      }
       return rdata; 
   }
}



